exports.code = {};
exports.class = {};

exports.code.OK = 0;
exports.code.InternalError = 1;
exports.code.BadValue = 2;
exports.code.OBSOLETE_DuplicateKey = 3;
exports.code.NoSuchKey = 4;
exports.code.GraphContainsCycle = 5;
exports.code.HostUnreachable = 6;
exports.code.HostNotFound = 7;
exports.code.UnknownError = 8;
exports.code.FailedToParse = 9;
exports.code.CannotMutateObject = 10;
exports.code.UserNotFound = 11;
exports.code.UnsupportedFormat = 12;
exports.code.Unauthorized = 13;
exports.code.TypeMismatch = 14;
exports.code.Overflow = 15;
exports.code.InvalidLength = 16;
exports.code.ProtocolError = 17;
exports.code.AuthenticationFailed = 18;
exports.code.CannotReuseObject = 19;
exports.code.IllegalOperation = 20;
exports.code.EmptyArrayOperation = 21;
exports.code.InvalidBSON = 22;
exports.code.AlreadyInitialized = 23;
exports.code.LockTimeout = 24;
exports.code.RemoteValidationError = 25;
exports.code.NamespaceNotFound = 26;
exports.code.IndexNotFound = 27;
exports.code.PathNotViable = 28;
exports.code.NonExistentPath = 29;
exports.code.InvalidPath = 30;
exports.code.RoleNotFound = 31;
exports.code.RolesNotRelated = 32;
exports.code.PrivilegeNotFound = 33;
exports.code.CannotBackfillArray = 34;
exports.code.UserModificationFailed = 35;
exports.code.RemoteChangeDetected = 36;
exports.code.FileRenameFailed = 37;
exports.code.FileNotOpen = 38;
exports.code.FileStreamFailed = 39;
exports.code.ConflictingUpdateOperators = 40;
exports.code.FileAlreadyOpen = 41;
exports.code.LogWriteFailed = 42;
exports.code.CursorNotFound = 43;
exports.code.UserDataInconsistent = 45;
exports.code.LockBusy = 46;
exports.code.NoMatchingDocument = 47;
exports.code.NamespaceExists = 48;
exports.code.InvalidRoleModification = 49;
exports.code.ExceededTimeLimit = 50;
exports.code.ManualInterventionRequired = 51;
exports.code.DollarPrefixedFieldName = 52;
exports.code.InvalidIdField = 53;
exports.code.NotSingleValueField = 54;
exports.code.InvalidDBRef = 55;
exports.code.EmptyFieldName = 56;
exports.code.DottedFieldName = 57;
exports.code.RoleModificationFailed = 58;
exports.code.CommandNotFound = 59;
exports.code.OBSOLETE_DatabaseNotFound = 60;
exports.code.ShardKeyNotFound = 61;
exports.code.OplogOperationUnsupported = 62;
exports.code.StaleShardVersion = 63;
exports.code.WriteConcernFailed = 64;
exports.code.MultipleErrorsOccurred = 65;
exports.code.ImmutableField = 66;
exports.code.CannotCreateIndex = 67;
exports.code.IndexAlreadyExists = 68;
exports.code.AuthSchemaIncompatible = 69;
exports.code.ShardNotFound = 70;
exports.code.ReplicaSetNotFound = 71;
exports.code.InvalidOptions = 72;
exports.code.InvalidNamespace = 73;
exports.code.NodeNotFound = 74;
exports.code.WriteConcernLegacyOK = 75;
exports.code.NoReplicationEnabled = 76;
exports.code.OperationIncomplete = 77;
exports.code.CommandResultSchemaViolation = 78;
exports.code.UnknownReplWriteConcern = 79;
exports.code.RoleDataInconsistent = 80;
exports.code.NoMatchParseContext = 81;
exports.code.NoProgressMade = 82;
exports.code.RemoteResultsUnavailable = 83;
exports.code.DuplicateKeyValue = 84;
exports.code.IndexOptionsConflict = 85;
exports.code.IndexKeySpecsConflict = 86;
exports.code.CannotSplit = 87;
exports.code.SplitFailed_OBSOLETE = 88;
exports.code.NetworkTimeout = 89;
exports.code.CallbackCanceled = 90;
exports.code.ShutdownInProgress = 91;
exports.code.SecondaryAheadOfPrimary = 92;
exports.code.InvalidReplicaSetConfig = 93;
exports.code.NotYetInitialized = 94;
exports.code.NotSecondary = 95;
exports.code.OperationFailed = 96;
exports.code.NoProjectionFound = 97;
exports.code.DBPathInUse = 98;
exports.code.CannotSatisfyWriteConcern = 100;
exports.code.OutdatedClient = 101;
exports.code.IncompatibleAuditMetadata = 102;
exports.code.NewReplicaSetConfigurationIncompatible = 103;
exports.code.NodeNotElectable = 104;
exports.code.IncompatibleShardingMetadata = 105;
exports.code.DistributedClockSkewed = 106;
exports.code.LockFailed = 107;
exports.code.InconsistentReplicaSetNames = 108;
exports.code.ConfigurationInProgress = 109;
exports.code.CannotInitializeNodeWithData = 110;
exports.code.NotExactValueField = 111;
exports.code.WriteConflict = 112;
exports.code.InitialSyncFailure = 113;
exports.code.InitialSyncOplogSourceMissing = 114;
exports.code.CommandNotSupported = 115;
exports.code.DocTooLargeForCapped = 116;
exports.code.ConflictingOperationInProgress = 117;
exports.code.NamespaceNotSharded = 118;
exports.code.InvalidSyncSource = 119;
exports.code.OplogStartMissing = 120;
exports.code.DocumentValidationFailure = 121; // Only for the document validator on collections.
exports.code.OBSOLETE_ReadAfterOptimeTimeout = 122;
exports.code.NotAReplicaSet = 123;
exports.code.IncompatibleElectionProtocol = 124;
exports.code.CommandFailed = 125;
exports.code.RPCProtocolNegotiationFailed = 126;
exports.code.UnrecoverableRollbackError = 127;
exports.code.LockNotFound = 128;
exports.code.LockStateChangeFailed = 129;
exports.code.SymbolNotFound = 130;
exports.code.RLPInitializationFailed = 131;
exports.code.ConfigServersInconsistent = 132;
exports.code.FailedToSatisfyReadPreference = 133;
exports.code.ReadConcernMajorityNotAvailableYet = 134;
exports.code.StaleTerm = 135;
exports.code.CappedPositionLost = 136;
exports.code.IncompatibleShardingConfigVersion = 137;
exports.code.RemoteOplogStale = 138;
exports.code.JSInterpreterFailure = 139;
exports.code.InvalidSSLConfiguration = 140;
exports.code.SSLHandshakeFailed = 141;
exports.code.JSUncatchableError = 142;
exports.code.CursorInUse = 143;
exports.code.IncompatibleCatalogManager = 144;
exports.code.PooledConnectionsDropped = 145;
exports.code.ExceededMemoryLimit = 146;
exports.code.ZLibError = 147;
exports.code.ReadConcernMajorityNotEnabled = 148;
exports.code.NoConfigMaster = 149;
exports.code.StaleEpoch = 150;
exports.code.OperationCannotBeBatched = 151;
exports.code.OplogOutOfOrder = 152;
exports.code.ChunkTooBig = 153;
exports.code.InconsistentShardIdentity = 154;
exports.code.CannotApplyOplogWhilePrimary = 155;
exports.code.NeedsDocumentMove = 156;
exports.code.CanRepairToDowngrade = 157;
exports.code.MustUpgrade = 158;
exports.code.DurationOverflow = 159;
exports.code.MaxStalenessOutOfRange = 160;
exports.code.IncompatibleCollationVersion = 161;

// Non-sequential error codes (for compatibility only)
exports.code.SocketException = 9001;
exports.code.RecvStaleConfig = 9996;
exports.code.NotMaster = 10107;
exports.code.CannotGrowDocumentInCappedNamespace = 10003;
exports.code.DuplicateKey = 11000;
exports.code.InterruptedAtShutdown = 11600;
exports.code.Interrupted = 11601;
exports.code.InterruptedDueToReplStateChange = 11602;
exports.code.OutOfDiskSpace = 14031;
exports.code.KeyTooLong = 17280;
exports.code.BackgroundOperationInProgressForDatabase = 12586;
exports.code.BackgroundOperationInProgressForNamespace = 12587;
exports.code.NotMasterOrSecondary = 13436;
exports.code.NotMasterNoSlaveOk = 13435;
exports.code.ShardKeyTooBig = 13334;
exports.code.SendStaleConfig = 13388;
exports.code.DatabaseDifferCase = 13297;
exports.code.OBSOLETE_PrepareConfigsFailed = 13104;

// SERVER-21428 explains the extra changes needed if error_class components change.
exports.class.NetworkError = [exports.code.HostUnreachable, exports.code.HostNotFound, exports.code.NetworkTimeout];
exports.class.Interruption = [exports.code.Interrupted,
                             exports.code.InterruptedAtShutdown,
                             exports.code.InterruptedDueToReplStateChange,
                             exports.code.ExceededTimeLimit];
exports.class.NotMasterError = [exports.code.NotMaster, exports.code.NotMasterNoSlaveOk];
exports.class.StaleShardingError =
            [exports.code.RecvStaleConfig, exports.code.SendStaleConfig, exports.code.StaleShardVersion, exports.code.StaleEpoch];
exports.class.WriteConcernError = [exports.code.WriteConcernFailed,
                                  exports.code.WriteConcernLegacyOK,
                                  exports.code.UnknownReplWriteConcern,
                                  exports.code.CannotSatisfyWriteConcern];
